import socket
import sys
from quixote.server.scgi_server import run

import publisher

def start(args):
    run_kwargs = {}
    run_kwargs['port'] = 3954

    i = 0
    while i < len(args):
        if args[i] == '--port':
            run_kwargs['port'] = int(args[i+1])
            i += 1
        elif args[i] == '--script-name':
            run_kwargs['script_name'] = args[i+1]
            i += 1
        i += 1

    try:
        run(publisher.WcsInstPublisher.create_publisher, **run_kwargs)
    except socket.error, e:
        if e[0] == 98:
            print >> sys.stderr, 'address already in use'
            sys.exit(1)
        raise
    except KeyboardInterrupt:
        sys.exit(1)

